<copyright> C Math class.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1995, 1996 Pieter J. Schoenmakers.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: Math.t,v 1.9 2000/11/18 11:42:45 bruce Exp $</id>  </copyright>

<doc> The {Math} class wraps the standard mathematical functions
    present within libc.  </doc>
implementation class Math

<doc> Return the length of the hypotenuse of a right triangle whose
    sides measure {x} and {y} in length.  </doc>
extern double hypot (double, double) (x, y);
extern double lgamma double x;

/* Error functions. */
extern double erf double x;
extern double erfc double x;

/* Bessel functions. */
extern double j0 double x;
extern double j1 double x;
extern double jn (int, double) (x, n);
extern double y0 double x;
extern double y1 double x;
extern double yn (int, double) (x, n);

<doc> Return the arc cosine of {x}.  {x} must not fall outside the
    range -1 to 1.  The return value will be in radians.  </doc>
extern double acos double x;

<doc> Return the arc sine of {x}.  {x} must not fall outside the range
    -1 to 1.  The return value will be in radians.  </doc>
extern double asin double x;

<doc> Return the arc tangent of {x}.  The return value will be in 
    radians.  </doc>
extern double atan double x;

<doc>  Return the arc tangent of {y}/{x}, using the signs of the 
    arguments to determine the quadrant of the return value.  The 
    return value will be in radians.  </doc>
extern double atan2 (double, double) (x, y);

<doc> Return the cosine of {x}.  The return value will be in radians  </doc>
extern double cos double x;

<doc> Return the sine of {x}.  The return value will be in radians.  </doc>
extern double sin double x;

<doc> Return the tangent of {x}.  The return value will be in
    radians.  </doc>
extern double tan double x;

<doc> Return the hyperbolic cosine of {x}.  The return value will be
    in radians.  </doc>
extern double cosh double x;

<doc> Return the hyperbolic sine of {x}.  The return value will be
    in radians.  </doc>
extern double sinh double x;

<doc> Return the hyperbolic tangent of {x}.  The return value will be
    in radians.  </doc>
extern double tanh double x;

<doc> Return the result of computing e^{x}.  </doc>
extern double exp double x;

<doc> Return the result of computing {x} * 2^{n}.  </doc>
extern double ldexp (double, int) (x, n);

<doc> Return the natural log of {x}. {x} must be positive.  </doc>
extern double log double x;

<doc> Return the log of {x} in base 10. {x} must be positive.  </doc>
extern double log10 double x;

<doc> Return the value of {x} raised to the power {y}, {x}^{y}.  If
    {x} is negative, {y} must be an integer value.  </doc>
extern double pow (double, double) (x, y);

<doc> Return the square root of {x}.  </doc>
extern double sqrt double x;

<doc> Return the value of {x} rounded up to the nearest integer.  </doc>
extern double ceil double x;

<doc> Return the absolute value of {x}.  </doc>
extern double fabs double x;

<doc> Return the value of {x} rounded down to the nearest integer.  </doc>
extern double floor double x;

<doc> Return the remainder of dividing {x} by {y}.  </doc>
extern double fmod (double, double) (x, y);

end;

implementation instance Math
end;
