/*
   Written by Pieter J. Schoenmakers <tiggr@ics.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: os.c,v 1.12 2000/05/11 20:15:56 tiggr Exp $  */

#include <dl.h>

/******************** dynamic loading ********************/

void
dload_initialize ()
{
}

char *
dload_error (void)
{
  return "unknown error";
}

void *
dload_load (char *name)
{
  return shl_load (name, BIND_IMMEDIATE | BIND_VERBOSE, 0);
}

void *
dload_lookup (void *handle, char *name)
{
  void *value;

  if (shl_findsym ((void *) &handle, name, TYPE_UNDEFINED, &value))
    value = NULL;

  return value;
}

void
dload_symbol_info (void *address,
		   i_tom_ByteString *file_name,
		   void **base_address,
		   i_tom_ByteString *symbol_name,
		   void **symbol_address,
		   void **offset)
{
  *file_name = *base_address = *symbol_name = *symbol_address = *offset = 0;
}
